<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - Association Lists</TITLE>
<link href="suif1_95.html" rel=Next>
<link href="suif1_93.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_93.html">previous</A>, <A HREF="suif1_95.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC94" HREF="suif1_toc.html#TOC94">Association Lists</A></H2>
<P>
<A NAME="IDX666"></A>
<A NAME="IDX667"></A>

</P>
<P>
<A NAME="IDX668"></A>
<A NAME="IDX669"></A>
An association list element contains both a key and a data pointer.  The
data associated with a particular key can be retrieved with a simple
lookup method.  The key and data fields are both <CODE>void*</CODE> pointers.
Association lists are implemented by the <CODE>alist</CODE> and <CODE>alist_e</CODE>
classes in the files <TT>`alist.h'</TT> and <TT>`alist.cc'</TT>.  These classes
are derived from the generic list classes (see section <A HREF="suif1_92.html#SEC92">Generic Lists</A>) and
behave similarly.

</P>
<P>
<A NAME="IDX670"></A>
The <CODE>amtflist</CODE> class has the same interface as the <CODE>alist</CODE>
class and provides the same functionality.  The only difference is that
it is based on the move-to-front list class.  See section <A HREF="suif1_93.html#SEC93">Move-to-front Lists</A>.  You may want to use this if you expect your application to
access list elements with a high degree of locality.

</P>
<P>
<A NAME="IDX671"></A>
Like all of the other SUIF lists, the association lists have iterators
to make it easy for you to traverse them.  The <CODE>alist_iter</CODE> class
uses the same interface as the generic list iterator and works for both
<CODE>alist</CODE> and <CODE>amtflist</CODE> objects.

</P>

<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_93.html">previous</A>, <A HREF="suif1_95.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
